<?php
/*
RSSTail() and RSSLastPost() functions developed for GEEKLOG 2.1.3
By Michael S. DeBurger

masodo@infinitelyremote.com
webmaster@BlogDogIt.com 
"Bloggin' It While Doggin' It"

***** MUST be running PHP 5.6.x or better *****

Place this file in 'system' directory and call from 
lib-custom with the following:
include $_CONF['path_system'] . 'RSSLastPost.php';

Includes code lifted from the following sources:
 ======================================================================
 lastRSS 0.9.1 
 Simple yet powerfull PHP class to parse RSS files.
  by Vojtech Semecky, webmaster @ webdot . cz
  Latest version, features, manual and examples:
 	http://lastrss.webdot.cz/
 ======================================================================
 RSSAggregator function (available hack download on Geeklog.net)
  by 
    sakata SAKATA Yusuke  http://molekun.blogspot.com
 ======================================================================
 
and the Internet-at-Large   
    
*/

/**start for RSSAggregator by 
    sakata SAKATA Yusuke **/

function COM_rdfSort( $a, $b) 
{
  if ($a['date'] == $b['date']) return 0;
  return ($a['date'] > $b['date']) ? -1 : 1;
}

function COM_rdfFetch( $rdfurl, $maxheadlines = 0 )
{
  global $_CONF, $_TABLES;
        // Import the feed handling classes:
    require_once( $_CONF['path_system']
                  . '/classes/syndication/parserfactory.class.php' );
    require_once( $_CONF['path_system']
                  . '/classes/syndication/feedparserbase.class.php' );
    require_once( $_CONF['path_system']
                  . '/classes/syndication/atom.feed.class.php' );   
    require_once( $_CONF['path_system']
                  . '/classes/syndication/rdf.feed.class.php' );   
    require_once( $_CONF['path_system']
                  . '/classes/syndication/rss.feed.class.php' );              
     // Load the actual feed handlers:
    $factory = new FeedParserFactory( $_CONF['path_system']
                                      . '/classes/syndication/' );
    $factory->userAgent = 'GeekLog/' . VERSION;
    $result = $factory->reader( $rdfurl, $_CONF['default_charset'] );
    
    if( !$result )
    {
        // failed to aquire info, 0 out the block and log an error
        COM_errorLog( "Unable to aquire feed reader for $rdfurl", 1 );
	/*        COM_errorLog( $factory->errorStatus[0] . ' ' .
        	  	$factory->errorStatus[1] . ' ' .
        		$factory->errorStatus[2] );
	*/
    }
    return $result;
}


/**END RSSAggregator by 
    sakata SAKATA Yusuke **/


function my_preg_matcher ($pattern, $subject) {
		// start regullar expression
		preg_match($pattern, $subject, $out);

		// if there is some result... process it and return it
		if(isset($out[1])) {
			// Process CDATA (if present)
			if ($out[1]->CDATA == 'content') { // Get CDATA content (without CDATA tag)
				$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
			} elseif ($out[1]->CDATA == 'strip') { // Strip CDATA
				$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
			}

			// If code page is set convert character encoding to required
			if ($out[1]->cp != '')
				//$out[1] = $this->MyConvertEncoding($this->rsscp, $this->cp, $out[1]);
				$out[1] = iconv($out[1]->rsscp, $out[1]->cp.'//TRANSLIT', $out[1]);
			// Return result
			return trim($out[1]);
		} else {
		// if there is NO result, return empty string
			return '';
		}
	}

function ParseFeeder ($rss_url) {
               if ($f = @fopen($rss_url, 'r')) {
			$rss_content = '';
			while (!feof($f)) {
				$rss_content .= fgets($f, 4096);
			}
			fclose($f);
}
             // Parse IMAGE info
    $imagetags = array('title', 'url', 'link', 'width', 'height');
    preg_match("'<image.*?>(.*?)</image>'si", $rss_content, $out_imageinfo);
    if (isset($out_imageinfo[1])) {
        foreach($imagetags as $imagetag) {
            $temp = my_preg_matcher("'<$imagetag.*?>(.*?)</$imagetag>'si", $out_imageinfo[1]);
            if ($temp != '') $result['image_'.$imagetag] = $temp; // Set only if not empty
				}
			}
return $result;
}


// close opened html tags and make allowances
    function tagcloser ( $html )
        {
        //$html = preg_replace("/(width:)\s*(550px|600px)/", "$1 100%", $html);
        $html = preg_replace("/(width:)\s*(.)/", "$1 100%", $html);
        //$html = preg_replace("/(width=\")\s*(.)/", "$1 100%\" null=\"", $html);
        $html = str_replace('<table ', '<trouble ', $html);
        $html = preg_replace( "/(\015\012)|(\015)|(\012)/", '', $html );
        $html = str_replace('<iframe ', '<p style="font-size:11px; font-style:italic; color:gray; text-align: center;">[ iframe/video suppressed from feed ]</p><p style="width:0; height:0; border:0; border:none; visibility: hidden;" ', $html);
        $html = str_replace('</iframe>', '</p>', $html);
        //$html = str_replace('<img ', '<img style="width: 100%;"', $html);
        $html = str_replace('<br>', ' &nbsp ', $html);
        $html = str_replace('<br />', ' &nbsp ', $html);
        #put all opened tags into an array
        preg_match_all ( "#<([a-z]+)( .*)?(?!/)>#iU", $html, $result );
        $openedtags = $result[1];
        #put all closed tags into an array
        preg_match_all ( "#</([a-z]+)>#iU", $html, $result );
        $closedtags = $result[1];
        $len_opened = count ( $openedtags );
        # all tags are closed
        if( count ( $closedtags ) == $len_opened )
        {
        return $html;
        }
        $openedtags = array_reverse ( $openedtags );
        # close tags
        for( $i = 0; $i < $len_opened; $i++ )
        {
            if ( !in_array ( $openedtags[$i], $closedtags ) )
            {
            $html .= "</" . $openedtags[$i] . ">";
            }
            else
            {
            unset ( $closedtags[array_search ( $openedtags[$i], $closedtags)] );
            }
        }
       
       return $html;
    }
    // close opened html tags


/** START RSSLastPost **/
function phpblock_RSSLastPost($var, $datarray)
{
        $delivered = $datarray;
        $data = explode('|', $delivered);

  Global $LANG21;   
        $retval = '';
        $rdfs = array('site'=>$data[0],
                  'slogan'=>$data[1],
  		  'url'=>$data[2]);
        $feed = COM_rdfFetch($rdfs['url'] , 0 );
        $ShowSite = $rdfs['site'];
        $ShowSlogan = $rdfs['slogan'];
        $logo = ParseFeeder($rdfs['url']);
        $articles = $feed->articles[0];
    if ($articles) {
//truncate feed using last argument here
        $clipping = substr($articles['summary'],0,2048);
        $ShowSum = tagcloser($clipping) . '...';
        $ShowDate = $articles['date'];
// Show website logo (if presented)
    if ($logo != '') { 
        $content = '<p><a href="' . $logo['image_link'] . '" target="_blank" title="Visit ' . $rdfs['site'] . '"><img src="' . $logo['image_url'] . '" alt="' . $logo['image_title'] . '" vspace="1" border="0" width="80" /></a><br /><a href="' . $logo['image_link'] . '" target="_blank" title="Visit ' . $rdfs['site'] . '"><span style="font-size: 16px; color: black; font-style: italic;">' . $rdfs['site'] . '</span></a><br /><span style="font-size:10px; color:gray; line-height:75%">' . $rdfs['slogan'] . '</span><hr width="50%" align="center" />' . date("F j, Y", strtotime($ShowDate)) . '</span></p>';
        } else {
        $content = '<p><span style="font-size:10px; color:gray; line-height:75%">' . $rdfs['slogan'] . '</span><hr width="50%" align="center" />' . date("F j, Y", strtotime($ShowDate)) . '</span></p>';
        }
        
//Display Article	  
        $content = $content . '<div style="width:225px; overflow:hidden;"><b><a href="' . $articles['link'] . '\" target=\"_blank\" title=\"' . $articles['title'] . '">' . $articles['title'] . ' </b></a><br />';
        $content = $content . '<br />' . $ShowSum;
        
//RSS Feed Link Logo
          $retval = $content . '<p style="text-align: right;"><a href="' . $rdfs['url'] . '" title="Copy This Link Location For Feed" target="_blank"><img src="/images/icons/rsslogo.jpg" /></a></p></div>'; 
     }
     else
     {
      $retval = $LANG21[4];
     }
          
     return $retval;
}

function phpblock_rssTail( $sitename, $siteslogan, $siteurl )
{
  global $_CONF, $LANG21;  
      $retval = '';
      $rdfs = array( 'url'=>$siteurl, 'site'=>$sitename, 'slogan'=>$siteslogan );
      $feed = COM_rdfFetch($rdfs['url'] , 0 );
      $articles = $feed->articles[0];
      $logo = ParseFeeder($rdfs['url']);
      $ShowSum = $articles['summary'];
      $ShowDate = $articles['date'];
       // Show website logo (if presented)
    if ($logo != '') { 
        $content = '<p><a href=\"' . $logo['image_link'] . '\" target=\"_blank\" title=\"Visit ' . $rdfs['site'] . '\"><img src=\"' . $logo['image_url'] . '\" alt=\"' . $logo['image_title'] . '\" vspace=\"1\" border=\"0\" width=\"80\" /></a><br /><a href=\"' . $logo['image_link'] . '\" target=\"_blank\" title=\"Visit ' . $rdfs['site'] . '\"><span style=\"font-size: 16px; color: black; font-style: italic;\">' . $rdfs['site'] . '</span></a><br /><span style="font-size:10px; color:gray; line-height:75%">' . $rdfs['slogan'] . '</span></p><br />';
        } else {
        //$content = '<p><span style=\"font-size: 16px; color: black; font-weight: bold;\">' . $rdfs['site'] . '</span><br /><span style="font-size:10px; color:gray; line-height:75%">' . $rdfs['slogan'] . '</span><br />';
        $content = '<p><span style="font-size:10px; color:gray; line-height:75%">' . $rdfs['slogan'] . '</span></p>';
        }
      $content = $content . '<b><a href=\"' . $articles['link'] . '\">' . $articles['title'] . '</a></b><br />';
      $content = $content . '<br />' . $ShowSum . '<br />' ;
      $content = str_replace('<iframe ', '<iframe style=\"width:0; height:0; border:0; border:none; visibility: hidden;\" ', $content);
      $content = $content . '<p style=\"text-align: center;\"><a href=\"' . $articles['link'] . '\" ><i> ~ ' . $rdfs['site'] . ' ~</i></a><br />' . date("F j, Y", strtotime($ShowDate)) . '</p><div>';
      //RSS Feed Link Logo
      $content = $content . '<p style="text-align: right;"><a href="' . $rdfs['url'] . '" title="Copy This Link Location For Feed" target="_blank"><img src="/images/icons/rsslogo.jpg" /></a></p>';
      $retval = preg_replace( "/(\015\012)|(\015)|(\012)/", '', $content ); #comment out for test
      $retval = $content;  #comment out for test
      //$retval = $retval . 'DUMP~' .  var_dump($articles) . '~DUMP'; #alt for testing dump
      //$retval = $retval . 'DUMP~' .  var_dump($logo) . '~DUMP'; #alt for testing dump
  return $retval;
}
?>